'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  return {
    visitor: topLevelVisitor
  };
};

var _babelTemplate = require('babel-template');

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UNDEFINED = t.identifier('undefined');

var buildAssignmentStatement = (0, _babelTemplate2.default)('\n  LEFT = RIGHT;\n');

var topLevelVisitor = {
  MemberExpression: function MemberExpression(path) {
    if (!path.get('object').isCallExpression()) {
      return;
    }

    var temporaryVariable = path.scope.generateUidIdentifier('a');
    path.scope.push({
      id: temporaryVariable
    });

    path.traverse(unchainingVisitor, {
      temporaryVariable: temporaryVariable
    });
    unchain(path, temporaryVariable);

    var referenceClearance = buildAssignmentStatement({
      LEFT: temporaryVariable,
      RIGHT: UNDEFINED
    });
    path.getStatementParent().insertAfter(referenceClearance);

    path.skip();
  }
};

var unchainingVisitor = {
  MemberExpression: {
    exit: function exit(path) {
      if (!path.get('object').isCallExpression()) {
        return;
      }

      unchain(path, this.temporaryVariable);
      path.skip();
    }
  }
};

function unchain(path, temporaryVariable) {
  var call = t.assignmentExpression('=', temporaryVariable, path.node.object);
  path.get('object').replaceWith(temporaryVariable);
  path.insertBefore(call);
}